/* Debug printing functions.

   Copyright (C) 2014-2020 Free Software Foundation, Inc.

   This file is part of GDB.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#include "defs.h"

#include "debug.h"

/* See gdbsupport/common-debug.h.  */

void
debug_vprintf (const char *fmt, va_list ap)
{
  vfprintf_unfiltered (gdb_stdlog, fmt, ap);
}

/* See debug.h.  */

void
debug_prefixed_vprintf (const char *module, const char *func, const char *format,
			va_list args)
{
  debug_printf ("[%s] %s: ", module, func);
  debug_vprintf (format, args);
  debug_printf ("\n");
}
